classification
Title: typing.AnyStr doc is unclear about python2 unicode support
Type: enhancement Stage:
Components: Documentation Versions: Python 3.7, Python 3.6, Python 3.3, Python 3.4, Python 3.5, Python 2.7
process
Status: closed Resolution: wont fix
Dependencies: Superseder:
Assigned To: docs@python Nosy List: Jim Fasarakis-Hilliard, aj, docs@python, gvanrossum, levkivskyi
Priority: normal Keywords:

Created on 2016-12-17 23:53 by aj, last changed 2017-01-07 22:00 by gvanrossum. This issue is now closed.

Messages (4)
msg283524 - (view) Author: Alex Jurkiewicz (aj) Date: 2016-12-17 23:53
The typing.AnyStr documentation:

https://docs.python.org/3/library/typing.html#typing.AnyStr

It gives some examples using u-strings (u'foo') but doesn't make explicit some subtleties about behaviour with Python 2. Specifically, with Python 2 all the given examples work, and even this works:

concat("foo", u"bar")

Which seems contrary to the goal of AnyStr being "used for functions that may accept any kind of string without allowing different kinds of strings to mix".

I think the documentation should call out that for Python 2, AnyStr doesn't distinguish between str & unicode, and mention that in python 2, b'str' is equivalent to 'str' (I know this is mentioned elsewhere, but it seems useful to repeat it here).
msg283526 - (view) Author: Jim Fasarakis-Hilliard (Jim Fasarakis-Hilliard) * Date: 2016-12-18 01:11
The ``typing`` module doesn't exist in Python 2.7. 

All code samples provided in the docs *work* since no type-checking is performed by Python. That is, no enforcing of the types provided is made, that's for 3rd party packages to supply.
msg283527 - (view) Author: Jim Fasarakis-Hilliard (Jim Fasarakis-Hilliard) * Date: 2016-12-18 01:33
Unless of course you mean pip installing typing for Py2 and then using ``# type``  comments to provide the types. 

Even in that case, I don't really think the documentation for Python 3.5 should be mentioning types in 2.7, that'd get confusing.
msg284940 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2017-01-07 22:00
I agree that it would just be confusing if the Python 3 docs were to explain Python 2 specific things.  Maybe this should be explained in the mypy docs (or maybe it's really a mypy bug).  Can you open an issue there?
History
Date User Action Args
2017-01-07 22:00:24gvanrossumsetstatus: open -> closed

nosy: + gvanrossum
messages: + msg284940

resolution: wont fix
2016-12-22 22:47:25levkivskyisetnosy: + levkivskyi
2016-12-18 01:33:52Jim Fasarakis-Hilliardsetmessages: + msg283527
2016-12-18 01:11:02Jim Fasarakis-Hilliardsetnosy: + Jim Fasarakis-Hilliard
messages: + msg283526
2016-12-17 23:53:44ajcreate